
#if defined(UseDumpFiles)
	#include <DumpHeader.h>
#endif



#include <Windows.h>
#include <QuickDraw.h>
#include <TextUtils.h>
#include <Fonts.h>

#include "DragSupport.h"
#include "ListCode.h"


WindowPtr	gWindow;

/*------------------------------------------------------------------*/

void DrawIt(WindowPtr win)
{	
#pragma unused (win)
}


/*------------------------------------------------------------------*/

pascal void DrawWindowContent(short pixelDepth, short dFlags, GDHandle theDevice, long theWin)
{
#pragma unused (pixelDepth, dFlags, theDevice)
	GrafPtr		savePort;

	GetPort(&savePort);
	SetPort((GrafPtr)theWin);

	DrawIt((WindowPtr)theWin);
	UpdateSourceList();
	UpdateDestList();

	SetPort(savePort);
}


/*------------------------------------------------------------------*/

void CreateNewWindow(void)
{
	Rect winDimension;
	GrafPtr		oldPort;

	SetRect(&winDimension, 60, 60, 320, 280);
	gWindow = NewCWindow(0L, &winDimension, "\pSample", true, noGrowDocProc,
							(WindowPtr)-1L, true, 0L);

	GetPort(&oldPort);
	SetPort(gWindow);
	TextFont(courier);
	TextFace(bold);
	TextSize(12);
	
	BuildSourceList(gWindow);
	AddToSourceList('roop');
	AddToSourceList('ROOP');
	AddToSourceList('Scop');
	AddToSourceList('ytyy');
	AddToSourceList('MACS');
	AddToSourceList('yty1');
	AddToSourceList('MAC1');
	AddToSourceList('MAC2');
	AddToSourceList('yty2');
	AddToSourceList('MAC2');
	AddToSourceList('3oop');
	AddToSourceList('3OOP');
	AddToSourceList('3cop');
	AddToSourceList('3tyy');
	AddToSourceList('3ACS');

	BuildDestList(gWindow);

	(void) InstallDragHandlers(gWindow);

	SetPort(oldPort);
}


/*------------------------------------------------------------------*/

void PreEventLoop(void)
{
	CreateNewWindow();
}


/*------------------------------------------------------------------*/

void DoUpdate(WindowPtr thisWindow)
{
	static DeviceLoopDrawingUPP	procForDeviceLoop = nil;

	SetPort(thisWindow);

	if ( procForDeviceLoop == nil )
		procForDeviceLoop = NewDeviceLoopDrawingProc(DrawWindowContent);	
	
	BeginUpdate(thisWindow);
	DeviceLoop(thisWindow->visRgn, procForDeviceLoop, (long)thisWindow, singleDevices);
	EndUpdate(thisWindow);
}


/*------------------------------------------------------------------*/

void PostEventLoop(void)
{
	if (gWindow != NULL)
		RemoveDragHandlers(gWindow);
}

